import { AbstractEntry } from "./AbstractEntry";
import { AbstractFileSystem } from "./AbstractFileSystem";
import { DeleteOptions, Directory, Entry, ErrorLike, ListOptions, MkcolOptions, XmitOptions } from "./core";
export declare abstract class AbstractDirectory extends AbstractEntry implements Directory {
    private afterList?;
    private afterMkcol?;
    private beforeList?;
    private beforeMkcol?;
    ls: (options?: ListOptions) => Promise<string[]>;
    mkdir: (options?: MkcolOptions) => Promise<void>;
    readdir: (options?: ListOptions) => Promise<string[]>;
    constructor(fs: AbstractFileSystem, path: string);
    _delete(options: DeleteOptions, errors: ErrorLike[]): Promise<void>;
    abstract _rmdir(): Promise<void>;
    _xmit(to: Entry, copyErrors: ErrorLike[], options: XmitOptions): Promise<void>;
    list(options?: ListOptions): Promise<string[]>;
    mkcol(options?: MkcolOptions): Promise<void>;
    abstract _list(): Promise<string[]>;
    abstract _mkcol(): Promise<void>;
}
//# sourceMappingURL=AbstractDirectory.d.ts.map