import { CopyOptions, DeleteOptions, Directory, Entry, ErrorLike, HeadOptions, MoveOptions, PatchOptions, Props, Stats, URLType, XmitOptions } from "./core";
import { AbstractFileSystem } from "./AbstractFileSystem";
export declare abstract class AbstractEntry implements Entry {
    readonly fs: AbstractFileSystem;
    path: string;
    private afterDelete?;
    private beforeDelete?;
    cp: (to: Entry, options?: CopyOptions) => Promise<ErrorLike[]>;
    del: (options?: DeleteOptions) => Promise<ErrorLike[]>;
    mv: (to: Entry, options?: MoveOptions) => Promise<ErrorLike[]>;
    rm: (options?: DeleteOptions) => Promise<ErrorLike[]>;
    stat: (options?: HeadOptions) => Promise<Stats>;
    constructor(fs: AbstractFileSystem, path: string);
    copy(to: Entry, options?: CopyOptions): Promise<ErrorLike[]>;
    delete(options?: DeleteOptions): Promise<ErrorLike[]>;
    getParent(): Promise<Directory>;
    head(options?: HeadOptions): Promise<Stats>;
    move(to: Entry, options?: MoveOptions): Promise<ErrorLike[]>;
    patch: (props: Props, options?: PatchOptions) => Promise<void>;
    toString: () => string;
    toURL: (urlType?: URLType | undefined) => Promise<string>;
    abstract _delete(option: DeleteOptions, errors: ErrorLike[]): Promise<void>;
    abstract _xmit(entry: Entry, copyErrors: ErrorLike[], options: XmitOptions): Promise<void>;
}
//# sourceMappingURL=AbstractEntry.d.ts.map