import { Converter, Source, SourceType } from "univ-conv";
import { XmitOptions } from ".";
import { AbstractEntry } from "./AbstractEntry";
import { AbstractFileSystem } from "./AbstractFileSystem";
import { DeleteOptions, ErrorLike, File, OpenOptions, ReadOptions, WriteOptions } from "./core";
export declare abstract class AbstractFile extends AbstractEntry implements File {
    private afterGet?;
    private afterPost?;
    private afterPut?;
    private beforeGet?;
    private beforePost?;
    private beforePut?;
    constructor(fs: AbstractFileSystem, path: string);
    _convert(converter: Converter, chunk: Source, type: SourceType): Promise<Source>;
    _delete(options: DeleteOptions, _errors: ErrorLike[]): Promise<void>;
    _xmit(toEntry: AbstractEntry, _copyErrors: ErrorLike[], options: XmitOptions): Promise<void>;
    hash(options?: OpenOptions): Promise<string>;
    read(options?: ReadOptions): Promise<Source>;
    write(src: Source, options?: WriteOptions): Promise<void>;
    protected _getConverter(bufferSize?: number): Converter;
    protected abstract _getSource(options: OpenOptions): Promise<Source>;
    protected abstract _rm(): Promise<void>;
    protected abstract _write(src: Source, options: WriteOptions): Promise<void>;
    private getSource;
}
//# sourceMappingURL=AbstractFile.d.ts.map